#Import Libraries
import tensorflow as tf
import matplotlib.pyplot as plt
import pandas as pd
import numpy as np

#Print Library Versions
print(tf.__version__)
print(pd.__version__)
print(np.__version__)

#Import Fashion MNIST dataset
fashion_mnist = tf.keras.datasets.fashion_mnist.load_data()
(X_train_full, y_train_full), (X_test, y_test) = fashion_mnist
X_train, y_train = X_train_full[:-5000], y_train_full[:-5000]
X_valid, y_valid = X_train_full[-5000:], y_train_full[-5000:]
X_train, X_valid, X_test = X_train / 255., X_valid / 255., X_test / 255.

# Clear the session to reset the name counters
tf.keras.backend.clear_session()
tf.random.set_seed(42)
np.random.seed(42)

#Define parameters for dense layers
###

#Define the model
model = tf.keras.Sequential([
    tf.keras.layers.Flatten(input_shape=[28, 28]),
    #These are the 2 dense layers that you have to change.
    ###
    tf.keras.layers.Dense(units=???, activation="relu"),
    tf.keras.layers.Dense(units=???, activation="relu"),
    ###
    tf.keras.layers.Dense(10, activation="softmax")
])

#Define parameters for learning rate
###


model.compile(loss=tf.keras.losses.sparse_categorical_crossentropy,
              optimizer=tf.keras.optimizers.SGD(learning_rate=???),
              metrics=[tf.keras.metrics.sparse_categorical_accuracy])

# Train the model for 30 epochs and get accuracy loss data

history = model.fit(X_train, y_train, epochs=30,validation_data=(X_valid, y_valid))
best_val_acc = np.max(history.history['val_sparse_categorical_accuracy'])
print('Best Accuracy on validation set:',best_val_acc)

#Plot validation and training losses, and accuracies
pd.DataFrame(history.history).plot(
    figsize=(8, 5), xlim=[0, 29], ylim=[0, 2], grid=True, xlabel="Epoch",
    style=["r--", "r--.", "b-", "b-*"])
plt.legend(loc="lower left")  # extra code
plt.show()
